/*  SpiralPlugin
 *  Copyleft (C) 2000 David Griffiths <dave@pawfal.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/ 

#include "XFadePluginGUI.h"
#include <FL/fl_draw.h>
#include <FL/fl_draw.H>

static const int GUI_COLOUR = 179;
static const int GUIBG_COLOUR = 144;
static const int GUIBG2_COLOUR = 145;

////////////////////////////////////////////

XFadePluginGUI::XFadePluginGUI(int w, int h,XFadePlugin *o,const HostInfo *Info) :
SpiralPluginGUI(w,h,o)
{	
	m_Plugin=o;
	
	m_Mix = new Fl_Slider(5, 20, 200, 20, "");
	m_Mix->type(FL_HORIZONTAL);
	m_Mix->selection_color(GUI_COLOUR);
    m_Mix->labelsize(10);
	m_Mix->maximum(1);
    m_Mix->step(0.0001);
    m_Mix->value(0.5);
    m_Mix->callback((Fl_Callback*)cb_Mix);
	
	end();
}

void XFadePluginGUI::UpdateValues()
{
	m_Mix->value(m_Plugin->GetMix());
}

inline void XFadePluginGUI::cb_Mix_i(Fl_Slider* o, void* v) 
{ 
	m_Plugin->SetMix(o->value()); 
}
void XFadePluginGUI::cb_Mix(Fl_Slider* o, void* v) 
{ ((XFadePluginGUI*)(o->parent()))->cb_Mix_i(o,v); }